Module SettingStuff
    Public Const APP_NAME As String = "howto_2005_store_passwords"

    ' Save the form's size and position.
    Public Sub SaveFormPosition(ByVal frm As Form, ByVal app_name As String, ByVal section_name As String)
        SaveSetting(app_name, section_name, "WindowState", frm.WindowState)
        If frm.WindowState = FormWindowState.Normal Then
            SaveSetting(app_name, section_name, "Left", frm.Left)
            SaveSetting(app_name, section_name, "Top", frm.Top)
            SaveSetting(app_name, section_name, "Width", frm.Width)
            SaveSetting(app_name, section_name, "Height", frm.Height)
        Else
            SaveSetting(app_name, section_name, "Left", frm.RestoreBounds.Left)
            SaveSetting(app_name, section_name, "Top", frm.RestoreBounds.Top)
            SaveSetting(app_name, section_name, "Width", frm.RestoreBounds.Width)
            SaveSetting(app_name, section_name, "Height", frm.RestoreBounds.Height)
        End If
    End Sub

    ' Restore the form's size and position.
    Public Sub RestoreFormPosition(ByVal frm As Form, ByVal app_name As String, ByVal section_name As String)
        frm.SetBounds( _
            GetSetting(app_name, section_name, "Left", frm.RestoreBounds.Left), _
            GetSetting(app_name, section_name, "Top", frm.RestoreBounds.Top), _
            GetSetting(app_name, section_name, "Width", frm.RestoreBounds.Width), _
            GetSetting(app_name, section_name, "Height", frm.RestoreBounds.Height) _
        )
        frm.WindowState = GetSetting(app_name, section_name, "WindowState", frm.WindowState)
    End Sub

    ' Save a DataGridView's column widths.
    Public Sub SaveDgvSettings(ByVal dgv As DataGridView, ByVal app_name As String, ByVal section_name As String)
        For i As Integer = 0 To dgv.ColumnCount - 1
            SaveSetting(app_name, section_name, "DgvColWidth" & i.ToString(), dgv.Columns(i).Width)
        Next i
    End Sub

    ' Restore a DataGridView's column widths.
    Public Sub RestoreDgvSettings(ByVal dgv As DataGridView, ByVal app_name As String, ByVal section_name As String)
        For i As Integer = 0 To dgv.ColumnCount - 1
            dgv.Columns(i).Width = _
                GetSetting(app_name, section_name, _
                "DgvColWidth" & i.ToString(), _
                dgv.Columns(i).Width)
        Next i
    End Sub
End Module
